#import <CoreGraphics/CoreGraphics.h>
#include <SDL_keysym.h>

#import <UIKit/UIKit.h>
#import <Foundation/NSThread.h>
#import <UIKit/UIKeyboard.h>
#include "../../video/iphone/SDL_iphonevideo.h"
#include "SDL_ControllerView.h"
#import <GraphicsServices/GraphicsServices.h>
#import <UIKit/UIView-Geometry.h>
#import <UIKit/UIPreferencesTable.h>
#import <UIKit/UIPreferencesTableCell.h>
#import <UIKit/UIPreferencesTextTableCell.h>
#import <UIKit/UIPreferencesControlTableCell.h>
#import <UIKit/UIPreferencesDeleteTableCell.h>
#import <UIKit/UISwitchControl.h>
#import <UIKit/UINavigationItem.h>
#import <UIKit/UITextField.h>
#import <UIKit/UISegmentedControl.h>

#import "../../../../src/iphone/SettingView.h"
#import "../../../../src/iphone/iphoneInterface.h"

  
//#import <CoreAudio/CoreAudio.h>

@interface SDL_iPhoneMain : UIApplication 
{
	UIWindow* _window;
	SDL_iPhoneView* _view;
    UIView* _contentView;
	SettingView* _settingView;
	UITransitionView* _transition;
	UITransitionView* _tabletransition;
	ControllerView *_controller;
}
- (void) mainLoop: (id)param;
- (SDL_iPhoneView*) getView;
- (UIView*) getContentView;
- (UIWindow*) getWindow;
- (float)systemVolume;
@end

static int gArgc;
static char **gArgv;

int main(int argc, char** argv)
{
	int i;
	
#if 0
	int out = open("/tmp/stdout", O_WRONLY|O_CREAT|O_TRUNC, 0644);
	if(out < 0) {
		[UIApp terminate];
	}
	dup2(out, 1);
	
	int err = open("/tmp/stderr", O_WRONLY|O_CREAT|O_TRUNC, 0644);
	if(err < 0) {
		[UIApp terminate];
	}
	dup2(err, 2);
#endif

	// when launched by the SpringBoard, there will be some command line options that need to
	// be stripped out for SDL_main() but need to be there for UIApplicationMain().  So, we'll make a
	// copy of argc/argv without the SpringBoard options and send that to SDL_main().
	//
	// actually, in all reality, if launched from the SpringBoard, none of the options are likely to be
	// for us.  But, to be safe, it's probably better to just strip out the ones we know are not for us and
	// to leave the rest alone.
	gArgc = 0;
	gArgv = NULL;
	for(i = 0; i < argc; i++) {
		if(!SDL_strcmp(argv[i], "--launchedFromSB")) {
			continue;
		}
		gArgc++;
		gArgv = (char **)realloc(gArgv, sizeof(char *) * gArgc);
		gArgv[gArgc - 1] = argv[i];
	}
	
	[[NSAutoreleasePool alloc] init];	
    return UIApplicationMain(argc, argv, [SDL_iPhoneMain class]);
} 

@implementation SDL_iPhoneMain

-(id) init
{
	[super init];
	_window = nil;
	_view = nil;
	return self;
}

- (void) mainLoop: (id)param
{
	[[NSAutoreleasePool alloc] init];
	
	SDL_main (gArgc, gArgv);
	[UIApp terminate];
}

- (SDL_iPhoneView*) getView
{
	return _view;
}

- (UIView*) getContentView
{
	return    _contentView;
;
}


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification 
{
	// hide the status bar
	//[UIHardware _setStatusBarHeight:0.0f];
	//[self setStatusBarMode:2 orientation:0 duration:0.0f fenceID:0];

    CGRect      fullscreenRect;
    fullscreenRect = [UIHardware fullScreenApplicationContentRect];
    _window = [[UIWindow alloc] initWithContentRect:fullscreenRect];

	
	[_window orderFront: self];
    [_window makeKey: self];
   	[_window _setHidden: NO];
	[_window retain];
	
    // Create content view
    CGRect  frame;
    frame.origin = CGPointZero;
    frame.size = fullscreenRect.size;
    _contentView = [[UIView alloc] initWithFrame:frame];
  
 	//setup transitonview
	_transition = [[UITransitionView alloc] initWithFrame:
	CGRectMake(0, 0, fullscreenRect.size.width, fullscreenRect.size.height)];
	[_transition setDelegate:self];
	
	//setup transitonview
	_tabletransition = [[UITransitionView alloc] initWithFrame:
	CGRectMake(0, NAVBARHEIGHT, fullscreenRect.size.width, fullscreenRect.size.height - NAVBARHEIGHT)];
	[_tabletransition setDelegate:self];

 
  	[_window setContentView: _transition];
	[_transition transition:0 toView:_contentView];   

    struct CGRect screenRect = [UIHardware fullScreenApplicationContentRect];
    screenRect.origin = CGPointZero;


	UINavigationBar*    navigationBar;
    CGSize              navigationBarSize;
    navigationBarSize = [UINavigationBar defaultSize];
    frame.origin = CGPointZero;
    frame.size = navigationBarSize;
    navigationBar = [[[UINavigationBar alloc] initWithFrame:frame] autorelease];

    // Set navigation bar buttons
    //[navigationBar showButtonsWithLeftTitle:@"Hello" rightTitle:@"World" leftBack:YES];
	[navigationBar showButtonsWithLeftTitle:@"Key" rightTitle:@"Settings"];
	[navigationBar setDelegate:self];

	_view = [[SDL_iPhoneView alloc] initWithFrame: CGRectMake(0, 52 - 10, screenRect.size.width, 480)];
 
	_controller = [[ControllerView alloc] initWithFrame: CGRectMake(0, fullscreenRect.size.height - 156 - 10, fullscreenRect.size.width, 156)];


    // Add navigation bar
    [_contentView addSubview:navigationBar];

	[_contentView addSubview: _view];
	
    /* \̈ɃL[{[hݒ */
//    [_view addSubview: keyboard];
      [_contentView addSubview: _controller];
   

	//setup _settingView
	_settingView = [[SettingView alloc] initWithFrame:CGRectMake(0, 0, fullscreenRect.size.width, fullscreenRect.size.height)];
	
	[_settingView setDelegate: self];

	
	printf("volume = %f\n", [self systemVolume]);
	[NSThread detachNewThreadSelector:@selector(mainLoop:) toTarget:self withObject:nil];
	iphone_quasi88_reset();
}

- (UIWindow*) getWindow
{
	return _window;
}

// Getting volume
- (float)systemVolume
{
    float               volume, volumeL, volumeR;
    OSStatus        	err;
//    AudioDeviceID       device;
    UInt32              size;
    UInt32              channels[2];
    
//    size = sizeof device;
//    err = AudioHardwareGetProperty(kAudioHardwarePropertyDefaultOutputDevice, &size, &device);
    
    size = sizeof channels;
//    if (noErr == err) err = AudioDeviceGetProperty(device, 0, false, kAudioDevicePropertyPreferredChannelsForStereo, &size, &channels);
    
    size = sizeof volume;
//    if (noErr == err) err = AudioDeviceGetProperty(device, channels[0], false, kAudioDevicePropertyVolumeScalar, &size, &volumeL);
//    if (noErr == err) err = AudioDeviceGetProperty(device, channels[1], false, kAudioDevicePropertyVolumeScalar, &size, &volumeR);
    
    if (noErr == err)
    {
        // Select greatest volume
        volume = (volumeL < volumeR) ? volumeR : volumeL;
    }
    else
    {
        volume = 1.0;	// Fallback
    }
    
    return volume;
}


- (void)settingView : (SettingView *)prefs done: (id) unused
{
	[_transition transition: 5 toView:_contentView];
	iphone_set_setting(&prefsData);

	if(TRUE == prefsData.Reset)
	{
		iphone_quasi88_reset();
	}

}


- (void)navigationBar:(UINavigationBar*)navigationBar buttonClicked:(int)button;
{
	if( 0 == button)
	{
		iphone_load_setting();
		[_transition transition: 8 toView: _settingView];
	}
	else
	{
		[_controller changeKeyMode];
	}
}

- (void)dealloc {
	[_transition release];
	[_tabletransition release];
	[_settingView release];
	[_contentView release]; 
	[_controller release];
	[super dealloc];
}
@end

@implementation ControllerView
- (id)initWithFrame:(CGRect)frame {
	if ((self == [super initWithFrame:frame])!=nil) {
					CGRect rect2;
					rect2.origin.x = 0;
					rect2.origin.y = 0;
					rect2.size.width = 320;
        			rect2.size.height = 156;

					_transitionView = [[UITransitionView alloc] initWithFrame:rect2];
					[self addSubview:_transitionView];
					[_transitionView setDelegate:self];

                   _controllerImageView = [[UIImageView alloc] initWithImage:[UIImage applicationImageNamed:@"pc88key.png"]];
                   _controllerImageTenKeyView =[[UIImageView alloc] initWithImage:[UIImage applicationImageNamed:@"pc88tenkey.png"]];

                   	[_transitionView transition:0 toView:_controllerImageView];
                   
				ESC=CGRectMake(0,0,31,25);
				STOP=CGRectMake(32,0,31,25);
				COPY=CGRectMake(64,0,31,25);
				F1=CGRectMake(96,0,31,25);
				F2=CGRectMake(128,0,31,25);
				F3=CGRectMake(160,0,31,25);
				F4=CGRectMake(192,0,31,25);
				F5=CGRectMake(224,0,31,25);
				PAGEUP=CGRectMake(256,0,31,25);
				PAGEDOWN=CGRectMake(288,0,31,25);
				K1=CGRectMake(0,26,31,25);
				K2=CGRectMake(32,26,31,25);
				K3=CGRectMake(64,26,31,25);
				K4=CGRectMake(96,26,31,25);
				K5=CGRectMake(128,26,31,25);
				K6=CGRectMake(160,26,31,25);
				K7=CGRectMake(192,26,31,25);
				K8=CGRectMake(224,26,31,25);
				K9=CGRectMake(256,26,31,25);
				K0=CGRectMake(288,26,31,25);
				Q=CGRectMake(0,52,31,25);
				W=CGRectMake(32,52,31,25);
				E=CGRectMake(64,52,31,25);
				R=CGRectMake(96,52,31,25);
				T=CGRectMake(128,52,31,25);
				Y=CGRectMake(160,52,31,25);
				U=CGRectMake(192,52,31,25);
				I=CGRectMake(224,52,31,25);
				O=CGRectMake(256,52,31,25);
				P=CGRectMake(288,52,31,25);
				A=CGRectMake(0,78,31,25);
				S=CGRectMake(32,78,31,25);
				D=CGRectMake(64,78,31,25);
				F=CGRectMake(96,78,31,25);
				G=CGRectMake(128,78,31,25);
				H=CGRectMake(160,78,31,25);
				J=CGRectMake(192,78,31,25);
				K=CGRectMake(224,78,31,25);
				L=CGRectMake(256,78,31,25);
				BS=CGRectMake(288,78,31,25);
				SHIFT=CGRectMake(0,104,31,25);
				Z=CGRectMake(32,104,31,25);
				X=CGRectMake(64,104,31,25);
				C=CGRectMake(96,104,31,25);
				V=CGRectMake(128,104,31,25);
				B=CGRectMake(160,104,31,25);
				N=CGRectMake(192,104,31,25);
				M=CGRectMake(224,104,31,25);
				ENTER=CGRectMake(256,104,31,25);
				UP=CGRectMake(288,104,31,25);
				CTRL=CGRectMake(0,130,31,25);
				KANA=CGRectMake(32,130,31,25);
				GRAPH=CGRectMake(64,130,31,25);
				SPACE=CGRectMake(96,130,31,25);
				COMMA=CGRectMake(128,130,31,25);
				PERIOD=CGRectMake(160,130,31,25);
				SLASH=CGRectMake(192,130,31,25);
				LEFT=CGRectMake(224,130,31,25);
				RIGHT=CGRectMake(256,130,31,25);
				DOWN=CGRectMake(288,130,31,25);
		
	}
	_preKey = SDLK_UNKNOWN;
	_ShiftOn = FALSE;
	_CtrlOn = FALSE;
	_KanaOn = FALSE;
	_KeyTenkeyMode = FALSE;
	return self;
}

- (void)dealloc {
	[_controllerImageView release];
	[_controllerImageTenKeyView release];

	[super dealloc];
}

- (void)drawRect:(CGRect)rect{
	CGRect rect2;
	rect2.origin.x = 0;
	rect2.origin.y = 0;
	rect2.size.width = 320;
        rect2.size.height = 156;



	[self fixRects];

}

- (BOOL)ignoresMouseEvents {

	return NO;
}

- (void)changeKeyMode {
	if( TRUE == _KeyTenkeyMode )
	{
		_KeyTenkeyMode = FALSE;
		[_transitionView transition:0 toView:_controllerImageView];
	}
	else
	{
		_KeyTenkeyMode = TRUE;
		[_transitionView transition:0 toView:_controllerImageTenKeyView];
	}


}


- (void)fixRects {
	if (_fixed)
		return;

	/* Because convertPoint:toView: was segfaulting on me... */

	SDL_iPhoneView *mainView = [UIApp getContentView];
	//Up = [self convertRect: Up toView: mainView];
	//Down = [self convertRect: Down toView: mainView];
	//Left = [self convertRect: Left toView: mainView];
	//Right = [self convertRect: Right toView: mainView];
	//Select = [self convertRect: Select toView: mainView];
	//Start = [self convertRect: Start toView: mainView];
	//B = [self convertRect: B toView: mainView];
	//A = [self convertRect: A toView: mainView];

	//UpLeft = [self convertRect: UpLeft toView: mainView];
	//UpRight = [self convertRect: UpRight toView: mainView];
	//DownLeft = [self convertRect: DownLeft toView: mainView];
	//DownRight = [self convertRect: DownRight toView: mainView];
				ESC = [self convertRect: ESC toView: mainView];
				STOP = [self convertRect: STOP toView: mainView];
				COPY = [self convertRect: COPY toView: mainView];
				F1 = [self convertRect: F1 toView: mainView];
				F2 = [self convertRect: F2 toView: mainView];
				F3 = [self convertRect: F3 toView: mainView];
				F4 = [self convertRect: F4 toView: mainView];
				F5 = [self convertRect: F5 toView: mainView];
				PAGEUP = [self convertRect: PAGEUP toView: mainView];
				PAGEDOWN = [self convertRect: PAGEDOWN toView: mainView];
				K1 = [self convertRect: K1 toView: mainView];
				K2 = [self convertRect: K2 toView: mainView];
				K3 = [self convertRect: K3 toView: mainView];
				K4 = [self convertRect: K4 toView: mainView];
				K5 = [self convertRect: K5 toView: mainView];
				K6 = [self convertRect: K6 toView: mainView];
				K7 = [self convertRect: K7 toView: mainView];
				K8 = [self convertRect: K8 toView: mainView];
				K9 = [self convertRect: K9 toView: mainView];
				K0 = [self convertRect: K0 toView: mainView];
				Q = [self convertRect: Q toView: mainView];
				W = [self convertRect: W toView: mainView];
				E = [self convertRect: E toView: mainView];
				R = [self convertRect: R toView: mainView];
				T = [self convertRect: T toView: mainView];
				Y = [self convertRect: Y toView: mainView];
				U = [self convertRect: U toView: mainView];
				I = [self convertRect: I toView: mainView];
				O = [self convertRect: O toView: mainView];
				P = [self convertRect: P toView: mainView];
				A = [self convertRect: A toView: mainView];
				S = [self convertRect: S toView: mainView];
				D = [self convertRect: D toView: mainView];
				F = [self convertRect: F toView: mainView];
				G = [self convertRect: G toView: mainView];
				H = [self convertRect: H toView: mainView];
				J = [self convertRect: J toView: mainView];
				K = [self convertRect: K toView: mainView];
				L = [self convertRect: L toView: mainView];
				BS = [self convertRect: BS toView: mainView];
				SHIFT = [self convertRect: SHIFT toView: mainView];
				Z = [self convertRect: Z toView: mainView];
				X = [self convertRect: X toView: mainView];
				C = [self convertRect: C toView: mainView];
				V = [self convertRect: V toView: mainView];
				B = [self convertRect: B toView: mainView];
				N = [self convertRect: N toView: mainView];
				M = [self convertRect: M toView: mainView];
				ENTER = [self convertRect: ENTER toView: mainView];
				UP = [self convertRect: UP toView: mainView];
				CTRL = [self convertRect: CTRL toView: mainView];
				KANA = [self convertRect: KANA toView: mainView];
				GRAPH = [self convertRect: GRAPH toView: mainView];
				SPACE = [self convertRect: SPACE toView: mainView];
				COMMA = [self convertRect: COMMA toView: mainView];
				PERIOD = [self convertRect: PERIOD toView: mainView];
				SLASH = [self convertRect: SLASH toView: mainView];
				LEFT = [self convertRect: LEFT toView: mainView];
				RIGHT = [self convertRect: RIGHT toView: mainView];
				DOWN = [self convertRect: DOWN toView: mainView];

	_fixed = YES;
}

- (void)controllerButtonPressed:(GSEvent *)event:(int)IsPressed {

	CGRect rect = GSEventGetLocationInWindow(event);
	CGPoint point = rect.origin;
        int button = 0;
       

	if(IsPressed != 1){
		if((_preKey !=SDLK_UNKNOWN)&&(_preKey!=SDLK_LSHIFT)&&(_preKey!=SDLK_LCTRL))
		{
			[[UIApp getView] addEvent:
				[NSDictionary dictionaryWithObjectsAndKeys:
				@"keyUp", @"type",
				[NSNumber numberWithInt:(int)_preKey], @"key",
				nil]
			];
			if(TRUE == _ShiftOn)
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyUp", @"type",
					[NSNumber numberWithInt:(int)SDLK_LSHIFT], @"key",
					nil]
				];
				_ShiftOn = FALSE;
			}
			if(TRUE == _CtrlOn)
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyUp", @"type",
					[NSNumber numberWithInt:(int)SDLK_LCTRL], @"key",
					nil]
				];
				_CtrlOn = FALSE;
			}

		}
		return;
	}

	SDLKey key ;
	key = SDLK_UNKNOWN;
		if(FALSE == _KeyTenkeyMode)
		{
				if (CGRectContainsPoint(ESC, point)) {  key = SDLK_ESCAPE;}
				else if (CGRectContainsPoint(STOP, point)) {  key = SDLK_PAUSE;}
				else if (CGRectContainsPoint(COPY, point)) {  key = SDLK_PRINT;}
				else if (CGRectContainsPoint(F1, point)) {  key = SDLK_F1;}
				else if (CGRectContainsPoint(F2, point)) {  key = SDLK_F2;}
				else if (CGRectContainsPoint(F3, point)) {  key = SDLK_F3;}
				else if (CGRectContainsPoint(F4, point)) {  key = SDLK_F4;}
				else if (CGRectContainsPoint(F5, point)) {  key = SDLK_F5;}
				else if (CGRectContainsPoint(PAGEUP, point)) {  key = SDLK_PAGEUP;}
				else if (CGRectContainsPoint(PAGEDOWN, point)) {  key = SDLK_PAGEDOWN;}
				else if (CGRectContainsPoint(K1, point)) {  key = SDLK_1;}
				else if (CGRectContainsPoint(K2, point)) {  key = SDLK_2;}
				else if (CGRectContainsPoint(K3, point)) {  key = SDLK_3;}
				else if (CGRectContainsPoint(K4, point)) {  key = SDLK_4;}
				else if (CGRectContainsPoint(K5, point)) {  key = SDLK_5;}
				else if (CGRectContainsPoint(K6, point)) {  key = SDLK_6;}
				else if (CGRectContainsPoint(K7, point)) {  key = SDLK_7;}
				else if (CGRectContainsPoint(K8, point)) {  key = SDLK_8;}
				else if (CGRectContainsPoint(K9, point)) {  key = SDLK_9;}
				else if (CGRectContainsPoint(K0, point)) {  key = SDLK_0;}
				else if (CGRectContainsPoint(Q, point)) {  key = SDLK_q;}
				else if (CGRectContainsPoint(W, point)) {  key = SDLK_w;}
				else if (CGRectContainsPoint(E, point)) {  key = SDLK_e;}
				else if (CGRectContainsPoint(R, point)) {  key = SDLK_r;}
				else if (CGRectContainsPoint(T, point)) {  key = SDLK_t;}
				else if (CGRectContainsPoint(Y, point)) {  key = SDLK_y;}
				else if (CGRectContainsPoint(U, point)) {  key = SDLK_u;}
				else if (CGRectContainsPoint(I, point)) {  key = SDLK_i;}
				else if (CGRectContainsPoint(O, point)) {  key = SDLK_o;}
				else if (CGRectContainsPoint(P, point)) {  key = SDLK_p;}
				else if (CGRectContainsPoint(A, point)) {  key = SDLK_a;}
				else if (CGRectContainsPoint(S, point)) {  key = SDLK_s;}
				else if (CGRectContainsPoint(D, point)) {  key = SDLK_d;}
				else if (CGRectContainsPoint(F, point)) {  key = SDLK_f;}
				else if (CGRectContainsPoint(G, point)) {  key = SDLK_g;}
				else if (CGRectContainsPoint(H, point)) {  key = SDLK_h;}
				else if (CGRectContainsPoint(J, point)) {  key = SDLK_j;}
				else if (CGRectContainsPoint(K, point)) {  key = SDLK_k;}
				else if (CGRectContainsPoint(L, point)) {  key = SDLK_l;}
				else if (CGRectContainsPoint(BS, point)) {  key = SDLK_BACKSPACE;}
				else if (CGRectContainsPoint(SHIFT, point)) {  key = SDLK_LSHIFT;}
				else if (CGRectContainsPoint(Z, point)) {  key = SDLK_z;}
				else if (CGRectContainsPoint(X, point)) {  key = SDLK_x;}
				else if (CGRectContainsPoint(C, point)) {  key = SDLK_c;}
				else if (CGRectContainsPoint(V, point)) {  key = SDLK_v;}
				else if (CGRectContainsPoint(B, point)) {  key = SDLK_b;}
				else if (CGRectContainsPoint(N, point)) {  key = SDLK_n;}
				else if (CGRectContainsPoint(M, point)) {  key = SDLK_m;}
				else if (CGRectContainsPoint(ENTER, point)) {  key = SDLK_RETURN;}
				else if (CGRectContainsPoint(UP, point)) {  key = SDLK_UP;}
				else if (CGRectContainsPoint(CTRL, point)) {  key = SDLK_LCTRL;}
				else if (CGRectContainsPoint(KANA, point)) {  key = SDLK_SCROLLOCK;}
				else if (CGRectContainsPoint(GRAPH, point)) {  key = SDLK_LALT;}
				else if (CGRectContainsPoint(SPACE, point)) {  key = SDLK_SPACE;}
				else if (CGRectContainsPoint(COMMA, point)) {  key = SDLK_COMMA;}
				else if (CGRectContainsPoint(PERIOD, point)) {  key = SDLK_PERIOD;}
				else if (CGRectContainsPoint(SLASH, point)) {  key = SDLK_SLASH;}
				else if (CGRectContainsPoint(LEFT, point)) {  key = SDLK_LEFT;}
				else if (CGRectContainsPoint(RIGHT, point)) {  key = SDLK_RIGHT;}
				else if (CGRectContainsPoint(DOWN, point)) {  key = SDLK_DOWN;}
				else {key = SDLK_UNKNOWN;}
			}
			else
			{
				if (CGRectContainsPoint(PAGEUP, point)) {  key = SDLK_F11;}
				else if (CGRectContainsPoint(PAGEDOWN, point)) {  key = SDLK_F12;}
				else if (CGRectContainsPoint(K7, point)) {  key = SDLK_HOME;}
				else if (CGRectContainsPoint(K8, point)) {  key = SDLK_HELP;}
				else if (CGRectContainsPoint(K9, point)) {  key = SDLK_KP_MINUS;}
				else if (CGRectContainsPoint(K0, point)) {  key = SDLK_KP_DIVIDE;}
				else if (CGRectContainsPoint(U, point)) {  key = SDLK_KP7;}
				else if (CGRectContainsPoint(I, point)) {  key = SDLK_KP8;}
				else if (CGRectContainsPoint(O, point)) {  key = SDLK_KP9;}
				else if (CGRectContainsPoint(P, point)) {  key = SDLK_KP_MULTIPLY;}
				else if (CGRectContainsPoint(J, point)) {  key = SDLK_KP4;}
				else if (CGRectContainsPoint(K, point)) {  key = SDLK_KP5;}
				else if (CGRectContainsPoint(L, point)) {  key = SDLK_KP6;}
				else if (CGRectContainsPoint(BS, point)) {  key = SDLK_KP_PLUS;}
				else if (CGRectContainsPoint(SHIFT, point)) {  key = SDLK_LSHIFT;}
				else if (CGRectContainsPoint(Z, point)) {  key = SDLK_z;}
				else if (CGRectContainsPoint(X, point)) {  key = SDLK_x;}
				else if (CGRectContainsPoint(C, point)) {  key = SDLK_c;}
				else if (CGRectContainsPoint(N, point)) {  key = SDLK_KP1;}
				else if (CGRectContainsPoint(M, point)) {  key = SDLK_KP2;}
				else if (CGRectContainsPoint(ENTER, point)) {  key = SDLK_KP3;}
				else if (CGRectContainsPoint(UP, point)) {  key = SDLK_KP_EQUALS;}
				else if (CGRectContainsPoint(GRAPH, point)) {  key = SDLK_SPACE;}
				else if (CGRectContainsPoint(SPACE, point)) {  key = SDLK_SPACE;}
				else if (CGRectContainsPoint(COMMA, point)) {  key = SDLK_SPACE;}
				else if (CGRectContainsPoint(PERIOD, point)) {  key = SDLK_SPACE;}
				else if (CGRectContainsPoint(SLASH, point)) {  key = SDLK_KP0;}
				else if (CGRectContainsPoint(LEFT, point)) {  key = SDLK_COMMA;}
				else if (CGRectContainsPoint(RIGHT, point)) {  key = SDLK_KP_PERIOD;}
				else if (CGRectContainsPoint(DOWN, point)) {  key = SDLK_KP_ENTER;}
				else {key = SDLK_UNKNOWN;}			
			
			
			}
	_preKey = key;

	if((key != SDLK_LSHIFT)&&(key != SDLK_LCTRL)&&(key != SDLK_SCROLLOCK))
	{
		[[UIApp getView] addEvent:
			[NSDictionary dictionaryWithObjectsAndKeys:
			@"keyDown", @"type",
			[NSNumber numberWithInt:(int)key], @"key",
			nil]
		];
	}else{
		if(key == SDLK_LSHIFT)
		{
			if(FALSE == _ShiftOn)
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyDown", @"type",
					[NSNumber numberWithInt:(int)key], @"key",
					nil]
				];
				_ShiftOn = TRUE;
			}
			else
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyUp", @"type",
					[NSNumber numberWithInt:(int)key], @"key",
					nil]
				];
				_ShiftOn = FALSE;
			}
		}
		if(key == SDLK_LCTRL)
		{
			if(FALSE == _CtrlOn)
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyDown", @"type",
					[NSNumber numberWithInt:(int)key], @"key",
					nil]
				];
				_CtrlOn = TRUE;
			}
			else
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyUp", @"type",
					[NSNumber numberWithInt:(int)key], @"key",
					nil]
				];
				_CtrlOn = FALSE;
			}
		}
		if(key == SDLK_SCROLLOCK)
		{
			if(FALSE == _KanaOn)
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyDown", @"type",
					[NSNumber numberWithInt:(int)key], @"key",
					nil]
				];
				_KanaOn = TRUE;
			}
			else
			{
				[[UIApp getView] addEvent:
					[NSDictionary dictionaryWithObjectsAndKeys:
					@"keyUp", @"type",
					[NSNumber numberWithInt:(int)key], @"key",
					nil]
				];
				_KanaOn = FALSE;
			}

		}
	}

	
	return ;
}

- (void)mouseDown:(GSEvent *)event {
	
	 [self controllerButtonPressed: event :1];
}


- (void)mouseUp:(GSEvent *)event {
	
    [self controllerButtonPressed: event :0];

}

@end
