/*

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include "iphoneInterface.h"

#import "ImageBrowser.h"
#import <UIKit/UISimpleTableCell.h>
#define MAXPATHLEN 512

@implementation ImageBrowser 
- (id)initWithFrame:(struct CGRect)frame{
	if ((self == [super initWithFrame: frame]) != nil) {
	
		CGRect navRect = CGRectMake(0,0,frame.size.width,NAVBARHEIGHT);
		//NavBarを作成
		_navBar = [[UINavigationBar alloc] initWithFrame:navRect];
		[_navBar enableAnimation];
		[_navBar setDelegate:self];
		//[_navBar setItemDelegate:self];

		//NavItemを作成
		UINavigationItem* navItem = [[UINavigationItem alloc] initWithTitle:NSLocalizedString(@"Image Select",@"")];
		[_navBar pushNavigationItem:navItem];
		[_navBar showLeftButton:nil withStyle:0 rightButton:NSLocalizedString(@"OK", nil) withStyle:3];
		[self addSubview: _navBar];

		UITableColumn *col = [[UITableColumn alloc]
			initWithTitle: @"ImageName"
			identifier:@"imagename"
			width: frame.size.width
		];
		_table = [[UITable alloc] initWithFrame: CGRectMake(0, NAVBARHEIGHT, frame.size.width, frame.size.height - NAVBARHEIGHT)];
		[_table addTableColumn: col];
		[_table setSeparatorStyle: 1];
		[_table setDelegate: self];
		[_table setDataSource: self];
		//_extensions = [[NSMutableArray alloc] init];
		_images = [[NSMutableArray alloc] init];
		_rowCount = 0;
		_delegate = nil;
		[self addSubview: _table];
	}

	return self;
}

- (void)dealloc {
	[_images release];
	[_table release];
	_delegate = nil;
	[super dealloc];
}


- (void)setOpenDrive:(int)openDrive
{
	_openDrive = openDrive;
}

- (void)reloadData {

	[_images removeAllObjects];
	if(_openDrive !=0)
	{
		int nIndex;
		NSString	*strDiskImage;
		for( nIndex = 1;nIndex < ext_getdiskimgs(0);nIndex++)
		{
			strDiskImage = [NSString stringWithFormat:@"%s", ext_getimgname(_openDrive - 1,nIndex)];	

			[_images addObject: strDiskImage];
		}
	
		//[_files sortUsingSelector:@selector(caseInsensitiveCompare:)];
	}
	_rowCount = [_images count];
	[_table reloadData];
	//[_table selectRow:1];
	//[tempArray release];
}

- (void)setDelegate:(id)delegate {
	_delegate = delegate;
}

- (int)numberOfRowsInTable:(UITable *)table {
	return _rowCount;
}


- (UITableCell *)table:(UITable *)table cellForRow:(int)row column:(UITableColumn *)col {
	UIImageAndTextTableCell *cell = [[UIImageAndTextTableCell alloc] init];
	[cell setTitle: [_images objectAtIndex: row] ];
	return cell;
}


- (void)tableRowSelected:(NSNotification *)notification {
//	NSLog([self selectedFile]);
//	if( [_delegate respondsToSelector:@selector( fileBrowser:fileSelected: )] )
//		[_delegate fileBrowser:self fileSelected:[self selectedFile]];
}

- (int)selectedImage
{
	return [_table selectedRow];
}

//------------------------delegate
- (void)navigationBar:(UINavigationBar*)navBar buttonClicked:(int)button
{
	{
		if( [_delegate respondsToSelector:@selector( EndSelectImage: )] )
		{	
			[_delegate EndSelectImage:self];
		}
	}
}



@end


