#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "quasi88.h"
#include "initval.h"
#include "menu.h"

#include "pc88main.h"
#include "pc88sub.h"
#include "graph.h"
#include "intr.h"
#include "keyboard.h"
#include "memory.h"
#include "screen.h"

#include "emu.h"
#include "drive.h"
#include "image.h"
#include "status.h"
#include "monitor.h"
#include "snddrv.h"
#include "wait.h"
#include "file-op.h"
#include "suspend.h"
#include "snapshot.h"
#include "fdc.h"
#include "soundbd.h"

#include "event.h"
#include "q8tk.h"

#include "iphoneInterface.h"
//#include "SettingView.h"

PreferenceData prefsData;


void iphone_quasi88_reset(){
	if(BASIC_AUTO == boot_basic)
	{
		boot_basic = BASIC_V2;
	}
    screen_size = SCREEN_SIZE_HALF;
	boot_clock_4mhz = FALSE;
  cpu_clock_mhz = boot_clock_4mhz ? CONST_4MHZ_CLOCK : CONST_8MHZ_CLOCK;

	if( disk_image_exist(0) ) boot_from_rom = FALSE; /* fBXN}DISK */
    else                      boot_from_rom = TRUE;  /* ȊÓA    ROM  */

	quasi88_reset();
}

void iphone_set_setting(){


//  boot_dipsw      = menu_boot_dipsw;
//  boot_from_rom   = menu_boot_from_rom;
  boot_basic      = prefsData.BasicMode;
  boot_clock_4mhz = prefsData.CPUClock?TRUE:FALSE;
  cpu_clock_mhz = boot_clock_4mhz ? CONST_4MHZ_CLOCK : CONST_8MHZ_CLOCK;

//  set_version     = menu_boot_version;
//  baudrate_sw     = menu_boot_baudrate;
//  sound_board     = menu_boot_sound_board;
	
}

void iphone_load_setting(){
	prefsData.Reset = FALSE;
	if(BASIC_AUTO == boot_basic)
	{
  		prefsData.BasicMode = BASIC_V2;
	}
	else
	{
		prefsData.BasicMode = boot_basic;
	}
	memset(prefsData.strDiskA,0,255);
	memset(prefsData.strDiskB,0,255);
	
	
	char slashcnt;
	slashcnt = strrchr(file_disk[0],'/');
	if (NULL!=slashcnt)
	{
		strcpy(prefsData.strDiskA ,file_disk[0]+ (int)slashcnt);
	}
	slashcnt = strrchr(file_disk[1],'/');
	if (NULL!=slashcnt)
	{
	    strcpy(prefsData.strDiskB ,file_disk[1]+ (int)slashcnt);
	}

}


void ext_setdip_disk(void)
{
	if (disk_image_exist(0) || disk_image_exist(1))
		prefsData.boot_from_rom = 0;
	else
		prefsData.boot_from_rom = 1;
}

int ext_opendisk(int drv,char *name)
{
    if( quasi88_disk_insert( drv,name, 0, 0 ) == FALSE)
	{
		//pop_about("ERROR : DISK OPEN ERROR");
		return -1;
    }

	disk_change_image( drv, 0 );
	
	ext_setdip_disk();
	
	return 0;
}

int ext_getdiskimgs(int drv)
{
	if (disk_image_exist(drv))
		return disk_image_num(drv)+1;
	return 0;
}

char *ext_getimgname(int drv,int img)
{
	if (!img)
	return "EJECT";
   else
    {
		if (drive[drv].empty || img < 0 || img > drive[drv].image_nr)
			return "";
		else
			return drive[drv].image[img-1].name;
    }
}

int ext_get_curimage(int drv)
{
  if (drive[drv].empty)
	return -1;

  return drive[drv].selected_image;
}

void ext_setdrvimage(int drv,int img)
{
	if (!img)
	{
		//pop_about("EJECT IMAGE");
		quasi88_disk_eject( drv );
	}
	else
	{				/* img>=0 Ȃ C[Wԍ */
		drive_unset_empty( drv );
		disk_change_image( drv, img-1 );
	}
	ext_setdip_disk();
}

void ext_ejectDisk(int drv)
{
	quasi88_disk_eject(drv);
	ext_setdip_disk();

}